/*----- PROTECTED REGION ID(TucsenCamStateMachine.cpp) ENABLED START -----*/
//
// file :        TucsenCamStateMachine.cpp
//
// description : C++ source for the �name� and its alowed
//               methods for commands and attributes
//

#include <TucsenCam.h>
#include <TucsenCamClass.h>

/*----- PROTECTED REGION END -----*/	//	TucsenCam::TucsenCamStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  The server is up anc connected to a camera
//  OFF     |  the server is up but it isn't connected to any camera
//  FAULT   |  A camera doesn't respond or the external trigger is missing (if the camera is configured with external trigger).
//  ALARM   |  When communication become unreliable.


namespace TucsenCam_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HorPos_allowed()
 * Description:  Execution allowed for HorPos attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HorPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HorPosStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HorPosStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_VerPos_allowed()
 * Description:  Execution allowed for VerPos attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_VerPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::VerPosStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::VerPosStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_MaxVal_allowed()
 * Description:  Execution allowed for MaxVal attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_MaxVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::MaxValStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::MaxValStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_CountMaxVal_allowed()
 * Description:  Execution allowed for CountMaxVal attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_CountMaxVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::CountMaxValStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::CountMaxValStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HorSigma_allowed()
 * Description:  Execution allowed for HorSigma attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HorSigma_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HorSigmaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HorSigmaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_VerSigma_allowed()
 * Description:  Execution allowed for VerSigma attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_VerSigma_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::VerSigmaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::VerSigmaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Area_allowed()
 * Description:  Execution allowed for Area attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Area_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::AreaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::AreaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HVCovar_allowed()
 * Description:  Execution allowed for HVCovar attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HVCovar_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HVCovarStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HVCovarStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_CameraCounter_allowed()
 * Description:  Execution allowed for CameraCounter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_CameraCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CameraCounter attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::CameraCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::CameraCounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AcquisitionCounter_allowed()
 * Description:  Execution allowed for AcquisitionCounter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AcquisitionCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::AcquisitionCounterStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::AcquisitionCounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Height_allowed()
 * Description:  Execution allowed for Height attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Height_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HeightStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HeightStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Width_allowed()
 * Description:  Execution allowed for Width attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Width_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::WidthStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::WidthStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ProcessingTime_allowed()
 * Description:  Execution allowed for ProcessingTime attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ProcessingTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::ProcessingTimeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::ProcessingTimeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Frequency_allowed()
 * Description:  Execution allowed for Frequency attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Frequency_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::FrequencyStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::FrequencyStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Trigger_allowed()
 * Description:  Execution allowed for Trigger attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Trigger_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Trigger attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerStateAllowed_WRITE

	//	Not any excluded states for Trigger attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Exposure_allowed()
 * Description:  Execution allowed for Exposure attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Exposure_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Exposure attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureStateAllowed_WRITE

	//	Not any excluded states for Exposure attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Gain_allowed()
 * Description:  Execution allowed for Gain attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Gain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Gain attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::GainStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainStateAllowed_WRITE

	//	Not any excluded states for Gain attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::GainStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_RoiThreshold_allowed()
 * Description:  Execution allowed for RoiThreshold attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_RoiThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RoiThreshold attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::RoiThresholdStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RoiThresholdStateAllowed_WRITE

	//	Not any excluded states for RoiThreshold attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::RoiThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RoiThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoRoi_allowed()
 * Description:  Execution allowed for AutoRoi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoRoi attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::AutoRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SwRoi_allowed()
 * Description:  Execution allowed for SwRoi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SwRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SwRoi attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::SwRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SwRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::SwRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::SwRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HwRoi_allowed()
 * Description:  Execution allowed for HwRoi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HwRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HwRoi attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::HwRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::HwRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HwRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HwRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_PlotMode_allowed()
 * Description:  Execution allowed for PlotMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_PlotMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotModeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotModeStateAllowed_WRITE

	//	Not any excluded states for PlotMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_IconSize_allowed()
 * Description:  Execution allowed for IconSize attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_IconSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IconSize attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::IconSizeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::IconSizeStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::IconSizeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::IconSizeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_LowPassOrder_allowed()
 * Description:  Execution allowed for LowPassOrder attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_LowPassOrder_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LowPassOrder attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::LowPassOrderStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::LowPassOrderStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::LowPassOrderStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::LowPassOrderStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Rotation_allowed()
 * Description:  Execution allowed for Rotation attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Rotation_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Rotation attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::RotationStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RotationStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::RotationStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::RotationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Mirror_allowed()
 * Description:  Execution allowed for Mirror attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Mirror_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Mirror attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::MirrorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::MirrorStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::MirrorStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::MirrorStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ImageDepth_allowed()
 * Description:  Execution allowed for ImageDepth attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ImageDepth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageDepth attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageDepthStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageDepthStateAllowed_WRITE

	//	Not any excluded states for ImageDepth attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageDepthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageDepthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_BackgroundSubtraction_allowed()
 * Description:  Execution allowed for BackgroundSubtraction attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_BackgroundSubtraction_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BackgroundSubtraction attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::BackgroundSubtractionStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BackgroundSubtractionStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::BackgroundSubtractionStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::BackgroundSubtractionStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_EnableProcessing_allowed()
 * Description:  Execution allowed for EnableProcessing attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_EnableProcessing_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableProcessing attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::EnableProcessingStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableProcessingStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::EnableProcessingStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableProcessingStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_FastProcessing_allowed()
 * Description:  Execution allowed for FastProcessing attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_FastProcessing_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FastProcessing attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::FastProcessingStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::FastProcessingStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::FastProcessingStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::FastProcessingStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Saturation_allowed()
 * Description:  Execution allowed for Saturation attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Saturation_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::SaturationStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::SaturationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_PlotLevel_allowed()
 * Description:  Execution allowed for PlotLevel attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_PlotLevel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotLevel attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotLevelStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotLevelStateAllowed_WRITE

	//	Not any excluded states for PlotLevel attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotLevelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotLevelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Pause_allowed()
 * Description:  Execution allowed for Pause attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Pause_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Pause attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::PauseStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PauseStateAllowed_WRITE

	//	Not any excluded states for Pause attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::PauseStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PauseStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Label_allowed()
 * Description:  Execution allowed for Label attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Label_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Label attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::LabelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::LabelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HorPosRelative_allowed()
 * Description:  Execution allowed for HorPosRelative attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HorPosRelative_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HorPosRelativeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HorPosRelativeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_VerPosRelative_allowed()
 * Description:  Execution allowed for VerPosRelative attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_VerPosRelative_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::VerPosRelativeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::VerPosRelativeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Phase_allowed()
 * Description:  Execution allowed for Phase attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Phase_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::PhaseStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::PhaseStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ScaleHor_allowed()
 * Description:  Execution allowed for ScaleHor attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ScaleHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScaleHor attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ScaleHorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ScaleHorStateAllowed_WRITE

	//	Not any excluded states for ScaleHor attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ScaleHorStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::ScaleHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ScaleVer_allowed()
 * Description:  Execution allowed for ScaleVer attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ScaleVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScaleVer attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ScaleVerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ScaleVerStateAllowed_WRITE

	//	Not any excluded states for ScaleVer attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ScaleVerStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::ScaleVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_OffsetHor_allowed()
 * Description:  Execution allowed for OffsetHor attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_OffsetHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OffsetHor attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::OffsetHorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::OffsetHorStateAllowed_WRITE

	//	Not any excluded states for OffsetHor attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::OffsetHorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::OffsetHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_OffsetVer_allowed()
 * Description:  Execution allowed for OffsetVer attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_OffsetVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OffsetVer attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::OffsetVerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::OffsetVerStateAllowed_WRITE

	//	Not any excluded states for OffsetVer attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::OffsetVerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::OffsetVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_PlotOffsetAxis_allowed()
 * Description:  Execution allowed for PlotOffsetAxis attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_PlotOffsetAxis_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotOffsetAxis attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotOffsetAxisStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotOffsetAxisStateAllowed_WRITE

	//	Not any excluded states for PlotOffsetAxis attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::PlotOffsetAxisStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::PlotOffsetAxisStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Intensity_allowed()
 * Description:  Execution allowed for Intensity attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Intensity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::IntensityStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::IntensityStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SignHor_allowed()
 * Description:  Execution allowed for SignHor attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SignHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SignHor attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::SignHorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SignHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SignVer_allowed()
 * Description:  Execution allowed for SignVer attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SignVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SignVer attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::SignVerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SignVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ProcessMode_allowed()
 * Description:  Execution allowed for ProcessMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ProcessMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ProcessMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ProcessModeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ProcessModeStateAllowed_WRITE

	//	Not any excluded states for ProcessMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ProcessModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ProcessModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_DebugThread_allowed()
 * Description:  Execution allowed for DebugThread attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_DebugThread_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DebugThread attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::DebugThreadStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::DebugThreadStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ImageBufferSize_allowed()
 * Description:  Execution allowed for ImageBufferSize attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ImageBufferSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageBufferSize attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageBufferSizeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageBufferSizeStateAllowed_WRITE

	//	Not any excluded states for ImageBufferSize attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageBufferSizeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageBufferSizeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ImageAcquisitionCounter_allowed()
 * Description:  Execution allowed for ImageAcquisitionCounter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ImageAcquisitionCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageAcquisitionCounter attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageAcquisitionCounterStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageAcquisitionCounterStateAllowed_WRITE

	//	Not any excluded states for ImageAcquisitionCounter attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageAcquisitionCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageAcquisitionCounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ExposureAutoEnable_allowed()
 * Description:  Execution allowed for ExposureAutoEnable attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ExposureAutoEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoEnable attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoEnableStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoEnable attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ExposureAutoMin_allowed()
 * Description:  Execution allowed for ExposureAutoMin attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ExposureAutoMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoMin attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoMinStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoMinStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoMin attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ExposureAutoMax_allowed()
 * Description:  Execution allowed for ExposureAutoMax attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ExposureAutoMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoMax attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoMaxStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoMaxStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoMax attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GainAutoEnable_allowed()
 * Description:  Execution allowed for GainAutoEnable attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GainAutoEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::GainAutoEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoEnableStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::GainAutoEnableStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoEnableStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GainAutoMin_allowed()
 * Description:  Execution allowed for GainAutoMin attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GainAutoMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GainAutoMin attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::GainAutoMinStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoMinStateAllowed_WRITE

	//	Not any excluded states for GainAutoMin attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::GainAutoMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GainAutoMax_allowed()
 * Description:  Execution allowed for GainAutoMax attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GainAutoMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GainAutoMax attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::GainAutoMaxStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoMaxStateAllowed_WRITE

	//	Not any excluded states for GainAutoMax attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::GainAutoMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoTargetValue_allowed()
 * Description:  Execution allowed for AutoTargetValue attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoTargetValue_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoTargetValue attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoTargetValueStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoTargetValueStateAllowed_WRITE

	//	Not any excluded states for AutoTargetValue attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoTargetValueStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoTargetValueStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoFeedbackGain_allowed()
 * Description:  Execution allowed for AutoFeedbackGain attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoFeedbackGain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackGain attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackGainStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackGainStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackGain attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackGainStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackGainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoFeedbackDws_allowed()
 * Description:  Execution allowed for AutoFeedbackDws attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoFeedbackDws_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackDws attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackDwsStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackDwsStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackDws attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackDwsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackDwsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoFeedbackTargetThres_allowed()
 * Description:  Execution allowed for AutoFeedbackTargetThres attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoFeedbackTargetThres_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackTargetThres attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackTargetThresStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackTargetThresStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackTargetThres attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackTargetThresStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackTargetThresStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoFeedbackDeadBand_allowed()
 * Description:  Execution allowed for AutoFeedbackDeadBand attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoFeedbackDeadBand_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackDeadBand attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackDeadBandStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackDeadBandStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackDeadBand attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::AutoFeedbackDeadBandStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoFeedbackDeadBandStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_FitError_allowed()
 * Description:  Execution allowed for FitError attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_FitError_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FitError attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::FitErrorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::FitErrorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_BunchNumber_allowed()
 * Description:  Execution allowed for BunchNumber attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_BunchNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BunchNumber attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::BunchNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BunchNumberStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_MeanIntensityThreshold_allowed()
 * Description:  Execution allowed for MeanIntensityThreshold attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_MeanIntensityThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MeanIntensityThreshold attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::MeanIntensityThresholdStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::MeanIntensityThresholdStateAllowed_WRITE

	//	Not any excluded states for MeanIntensityThreshold attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::MeanIntensityThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::MeanIntensityThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Binning_allowed()
 * Description:  Execution allowed for Binning attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Binning_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Binning attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::BinningStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BinningStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::BinningStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::BinningStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_DISEnable_allowed()
 * Description:  Execution allowed for DISEnable attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_DISEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DISEnable attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::DISEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::DISEnableStateAllowed_WRITE

	//	Not any excluded states for DISEnable attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::DISEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::DISEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_DisableTriggerTimeout_allowed()
 * Description:  Execution allowed for DisableTriggerTimeout attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_DisableTriggerTimeout_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DisableTriggerTimeout attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::DisableTriggerTimeoutStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::DisableTriggerTimeoutStateAllowed_WRITE

	//	Not any excluded states for DisableTriggerTimeout attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::DisableTriggerTimeoutStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::DisableTriggerTimeoutStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ImageSumSamples_allowed()
 * Description:  Execution allowed for ImageSumSamples attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ImageSumSamples_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageSumSamples attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageSumSamplesStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageSumSamplesStateAllowed_WRITE

	//	Not any excluded states for ImageSumSamples attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageSumSamplesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageSumSamplesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Model_allowed()
 * Description:  Execution allowed for Model attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Model_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Model attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ModelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ModelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_FeedbackMode_allowed()
 * Description:  Execution allowed for FeedbackMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_FeedbackMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FeedbackMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::FeedbackModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::FeedbackModeStateAllowed_WRITE

	//	Not any excluded states for FeedbackMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::FeedbackModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::FeedbackModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_MeanIntensity_allowed()
 * Description:  Execution allowed for MeanIntensity attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_MeanIntensity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MeanIntensity attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::MeanIntensityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::MeanIntensityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_FeedbackError_allowed()
 * Description:  Execution allowed for FeedbackError attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_FeedbackError_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FeedbackError attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::FeedbackErrorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::FeedbackErrorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_EnableMedianFilter_allowed()
 * Description:  Execution allowed for EnableMedianFilter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_EnableMedianFilter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableMedianFilter attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::EnableMedianFilterStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableMedianFilterStateAllowed_WRITE

	//	Not any excluded states for EnableMedianFilter attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::EnableMedianFilterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableMedianFilterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerMode_allowed()
 * Description:  Execution allowed for TriggerMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerModeStateAllowed_WRITE

	//	Not any excluded states for TriggerMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerExpMode_allowed()
 * Description:  Execution allowed for TriggerExpMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerExpMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerExpMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerExpModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerExpModeStateAllowed_WRITE

	//	Not any excluded states for TriggerExpMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerExpModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerExpModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerEdgeMode_allowed()
 * Description:  Execution allowed for TriggerEdgeMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerEdgeMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerEdgeMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerEdgeModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerEdgeModeStateAllowed_WRITE

	//	Not any excluded states for TriggerEdgeMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerEdgeModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerEdgeModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerDelayTime_allowed()
 * Description:  Execution allowed for TriggerDelayTime attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerDelayTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerDelayTime attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerDelayTimeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerDelayTimeStateAllowed_WRITE

	//	Not any excluded states for TriggerDelayTime attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerDelayTimeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerDelayTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutPort_allowed()
 * Description:  Execution allowed for TriggerOutPort attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutPort_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerOutPort attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutPortStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutPortStateAllowed_WRITE

	//	Not any excluded states for TriggerOutPort attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutPortStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutPortStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutMode_allowed()
 * Description:  Execution allowed for TriggerOutMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerOutMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutModeStateAllowed_WRITE

	//	Not any excluded states for TriggerOutMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutEdgeMode_allowed()
 * Description:  Execution allowed for TriggerOutEdgeMode attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutEdgeMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerOutEdgeMode attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutEdgeModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutEdgeModeStateAllowed_WRITE

	//	Not any excluded states for TriggerOutEdgeMode attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutEdgeModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutEdgeModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutDelayTime_allowed()
 * Description:  Execution allowed for TriggerOutDelayTime attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutDelayTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerOutDelayTime attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutDelayTimeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutDelayTimeStateAllowed_WRITE

	//	Not any excluded states for TriggerOutDelayTime attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutDelayTimeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutDelayTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutWidth_allowed()
 * Description:  Execution allowed for TriggerOutWidth attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TriggerOutWidth attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutWidthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutWidthStateAllowed_WRITE

	//	Not any excluded states for TriggerOutWidth attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutWidthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Temperature_allowed()
 * Description:  Execution allowed for Temperature attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Temperature_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Temperature attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TemperatureStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TemperatureStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TemperatureSetpoint_allowed()
 * Description:  Execution allowed for TemperatureSetpoint attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TemperatureSetpoint_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TemperatureSetpoint attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::TemperatureSetpointStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TemperatureSetpointStateAllowed_WRITE

	//	Not any excluded states for TemperatureSetpoint attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TemperatureSetpointStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TemperatureSetpointStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerInfo_allowed()
 * Description:  Execution allowed for TriggerInfo attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerInfo_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TriggerInfo attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerInfoStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerInfoStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TriggerOutInfo_allowed()
 * Description:  Execution allowed for TriggerOutInfo attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TriggerOutInfo_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TriggerOutInfo attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::TriggerOutInfoStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::TriggerOutInfoStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_CameraInfo_allowed()
 * Description:  Execution allowed for CameraInfo attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_CameraInfo_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CameraInfo attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::CameraInfoStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::CameraInfoStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_BunchNumberDataReadyDelay_allowed()
 * Description:  Execution allowed for BunchNumberDataReadyDelay attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_BunchNumberDataReadyDelay_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BunchNumberDataReadyDelay attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::BunchNumberDataReadyDelayStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BunchNumberDataReadyDelayStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_BunchNumberOffset_allowed()
 * Description:  Execution allowed for BunchNumberOffset attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_BunchNumberOffset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BunchNumberOffset attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::BunchNumberOffsetStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BunchNumberOffsetStateAllowed_WRITE

	//	Not any excluded states for BunchNumberOffset attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::BunchNumberOffsetStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::BunchNumberOffsetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_EnableCameraReadings_allowed()
 * Description:  Execution allowed for EnableCameraReadings attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_EnableCameraReadings_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableCameraReadings attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::EnableCameraReadingsStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableCameraReadingsStateAllowed_WRITE

	//	Not any excluded states for EnableCameraReadings attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::EnableCameraReadingsStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::EnableCameraReadingsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SearchBackgroundParam_allowed()
 * Description:  Execution allowed for SearchBackgroundParam attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SearchBackgroundParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SearchBackgroundParam attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::SearchBackgroundParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SearchBackgroundParamStateAllowed_WRITE

	//	Not any excluded states for SearchBackgroundParam attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::SearchBackgroundParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SearchBackgroundParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HorProfile_allowed()
 * Description:  Execution allowed for HorProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HorProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HorProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HorProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_VerProfile_allowed()
 * Description:  Execution allowed for VerProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_VerProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::VerProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::VerProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ErrorCounters_allowed()
 * Description:  Execution allowed for ErrorCounters attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ErrorCounters_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::ErrorCountersStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::ErrorCountersStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_TimeStamp_allowed()
 * Description:  Execution allowed for TimeStamp attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_TimeStamp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::TimeStampStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::TimeStampStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AutoRoiParam_allowed()
 * Description:  Execution allowed for AutoRoiParam attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AutoRoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::AutoRoiParamStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::AutoRoiParamStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_RoiParam_allowed()
 * Description:  Execution allowed for RoiParam attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_RoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RoiParam attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::RoiParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RoiParamStateAllowed_WRITE

	//	Not any excluded states for RoiParam attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::RoiParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RoiParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HorFitProfile_allowed()
 * Description:  Execution allowed for HorFitProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HorFitProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::HorFitProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::HorFitProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_VerFitProfile_allowed()
 * Description:  Execution allowed for VerFitProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_VerFitProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::VerFitProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::VerFitProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_HwRoiParam_allowed()
 * Description:  Execution allowed for HwRoiParam attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_HwRoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HwRoiParam attribute in Write access.
	/*----- PROTECTED REGION ID(TucsenCam::HwRoiParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::HwRoiParamStateAllowed_WRITE

	//	Not any excluded states for HwRoiParam attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::HwRoiParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::HwRoiParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image8_allowed()
 * Description:  Execution allowed for Image8 attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image8_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::Image8StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image8StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image8Icon_allowed()
 * Description:  Execution allowed for Image8Icon attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image8Icon_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::Image8IconStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image8IconStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image16_allowed()
 * Description:  Execution allowed for Image16 attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image16_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::Image16StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image16StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image16Icon_allowed()
 * Description:  Execution allowed for Image16Icon attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image16Icon_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TucsenCam::Image16IconStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image16IconStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image8Counter_allowed()
 * Description:  Execution allowed for Image8Counter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image8Counter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Image8Counter attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::Image8CounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image8CounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Image16Counter_allowed()
 * Description:  Execution allowed for Image16Counter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Image16Counter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Image16Counter attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::Image16CounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::Image16CounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ImageSum_allowed()
 * Description:  Execution allowed for ImageSum attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ImageSum_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ImageSum attribute in read access.
	/*----- PROTECTED REGION ID(TucsenCam::ImageSumStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ImageSumStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Start_allowed()
 * Description:  Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(TucsenCam::StartStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::StartStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Stop_allowed()
 * Description:  Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(TucsenCam::StopStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_Reset_allowed()
 * Description:  Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(TucsenCam::ResetStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ListCamera_allowed()
 * Description:  Execution allowed for ListCamera attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ListCamera_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ListCamera command.
	/*----- PROTECTED REGION ID(TucsenCam::ListCameraStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ListCameraStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_AcquireBackground_allowed()
 * Description:  Execution allowed for AcquireBackground attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_AcquireBackground_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::AcquireBackgroundStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::AcquireBackgroundStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetImage8_allowed()
 * Description:  Execution allowed for GetImage8 attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetImage8_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetImage8StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetImage8StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetImage16_allowed()
 * Description:  Execution allowed for GetImage16 attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetImage16_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetImage16StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetImage16StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetHorPos_allowed()
 * Description:  Execution allowed for GetHorPos attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetHorPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetHorPosStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetHorPosStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetVerPos_allowed()
 * Description:  Execution allowed for GetVerPos attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetVerPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetVerPosStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetVerPosStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetHorSigma_allowed()
 * Description:  Execution allowed for GetHorSigma attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetHorSigma_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetHorSigmaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetHorSigmaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetVerSigma_allowed()
 * Description:  Execution allowed for GetVerSigma attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetVerSigma_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetVerSigmaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetVerSigmaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetArea_allowed()
 * Description:  Execution allowed for GetArea attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetArea_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetAreaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetAreaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetAcquisitionCounter_allowed()
 * Description:  Execution allowed for GetAcquisitionCounter attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetAcquisitionCounter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetAcquisitionCounterStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetAcquisitionCounterStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetSaturation_allowed()
 * Description:  Execution allowed for GetSaturation attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetSaturation_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetSaturationStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetSaturationStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SetReference_allowed()
 * Description:  Execution allowed for SetReference attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SetReference_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetReference command.
	/*----- PROTECTED REGION ID(TucsenCam::SetReferenceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SetReferenceStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetPhase_allowed()
 * Description:  Execution allowed for GetPhase attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetPhase_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetPhaseStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetPhaseStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SaveScale_allowed()
 * Description:  Execution allowed for SaveScale attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SaveScale_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::SaveScaleStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SaveScaleStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_RestoreScale_allowed()
 * Description:  Execution allowed for RestoreScale attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_RestoreScale_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::RestoreScaleStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::RestoreScaleStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SetMeasurePoint_allowed()
 * Description:  Execution allowed for SetMeasurePoint attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SetMeasurePoint_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::SetMeasurePointStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SetMeasurePointStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ClearMeasurePoints_allowed()
 * Description:  Execution allowed for ClearMeasurePoints attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ClearMeasurePoints_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::ClearMeasurePointsStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ClearMeasurePointsStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetIntensity_allowed()
 * Description:  Execution allowed for GetIntensity attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetIntensity_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetIntensityStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetIntensityStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetHorProfile_allowed()
 * Description:  Execution allowed for GetHorProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetHorProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetHorProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetHorProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetVerProfile_allowed()
 * Description:  Execution allowed for GetVerProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetVerProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetVerProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetVerProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetHorFitProfile_allowed()
 * Description:  Execution allowed for GetHorFitProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetHorFitProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetHorFitProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetHorFitProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetVerFitProfile_allowed()
 * Description:  Execution allowed for GetVerFitProfile attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetVerFitProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetVerFitProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetVerFitProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SaveParam_allowed()
 * Description:  Execution allowed for SaveParam attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SaveParam_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SaveParam command.
	/*----- PROTECTED REGION ID(TucsenCam::SaveParamStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SaveParamStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ClearReference_allowed()
 * Description:  Execution allowed for ClearReference attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ClearReference_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ClearReference command.
	/*----- PROTECTED REGION ID(TucsenCam::ClearReferenceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ClearReferenceStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_ExposureAutoOnce_allowed()
 * Description:  Execution allowed for ExposureAutoOnce attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_ExposureAutoOnce_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::ExposureAutoOnceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::ExposureAutoOnceStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GainAutoOnce_allowed()
 * Description:  Execution allowed for GainAutoOnce attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GainAutoOnce_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GainAutoOnceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GainAutoOnceStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetFitError_allowed()
 * Description:  Execution allowed for GetFitError attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetFitError_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFitError command.
	/*----- PROTECTED REGION ID(TucsenCam::GetFitErrorStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetFitErrorStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetBunchNumber_allowed()
 * Description:  Execution allowed for GetBunchNumber attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetBunchNumber_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBunchNumber command.
	/*----- PROTECTED REGION ID(TucsenCam::GetBunchNumberStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetBunchNumberStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetMaxVal_allowed()
 * Description:  Execution allowed for GetMaxVal attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetMaxVal_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetMaxVal command.
	/*----- PROTECTED REGION ID(TucsenCam::GetMaxValStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetMaxValStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetGain_allowed()
 * Description:  Execution allowed for GetGain attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetGain_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGain command.
	/*----- PROTECTED REGION ID(TucsenCam::GetGainStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetGainStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetExposure_allowed()
 * Description:  Execution allowed for GetExposure attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetExposure_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetExposure command.
	/*----- PROTECTED REGION ID(TucsenCam::GetExposureStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetExposureStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetImage8Roi_allowed()
 * Description:  Execution allowed for GetImage8Roi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetImage8Roi_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetImage8RoiStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetImage8RoiStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetImage16Roi_allowed()
 * Description:  Execution allowed for GetImage16Roi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetImage16Roi_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetImage16RoiStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetImage16RoiStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetHorProfileRoi_allowed()
 * Description:  Execution allowed for GetHorProfileRoi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetHorProfileRoi_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetHorProfileRoiStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetHorProfileRoiStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_GetVerProfileRoi_allowed()
 * Description:  Execution allowed for GetVerProfileRoi attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_GetVerProfileRoi_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(TucsenCam::GetVerProfileRoiStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::GetVerProfileRoiStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TucsenCam::is_SWTrigger_allowed()
 * Description:  Execution allowed for SWTrigger attribute
 */
//--------------------------------------------------------
bool TucsenCam::is_SWTrigger_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SWTrigger command.
	/*----- PROTECTED REGION ID(TucsenCam::SWTriggerStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TucsenCam::SWTriggerStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(TucsenCam::TucsenCamStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	TucsenCam::TucsenCamStateAllowed.AdditionalMethods

}	//	End of namespace
